OGRE: Ogre::BillboardSet Class Reference - OGRE Documentation

# Ogre::BillboardSet Class Reference

A collection of billboards (faces which are always facing the given direction) with the same (default) dimensions, material and which are fairly close proximity to each other. More...

`#include <OgreBillboardSet.h>`

Inheritance diagram for Ogre::BillboardSet:

[legend]

List of all members.

## Public Types
typedef std::vector < ShadowRenderable * > | ShadowRenderableList
typedef VectorIterator < ShadowRenderableList > | ShadowRenderableListIterator
## Public Member Functions
| BillboardSet (const String &name, unsigned int poolSize=20, bool externalDataSource=false)
| Usual constructor - this is called by the SceneManager.
virtual | ~BillboardSet ()
Billboard * | createBillboard (const Vector3 &position, const ColourValue &colour=ColourValue::White)
| Creates a new billboard and adds it to this set.
Billboard * | createBillboard (Real x, Real y, Real z, const ColourValue &colour=ColourValue::White)
| Creates a new billboard and adds it to this set.
virtual int | getNumBillboards (void) const
| Returns the number of active billboards which currently make up this set.
virtual void | setAutoextend (bool autoextend)
| Tells the set whether to allow automatic extension of the pool of billboards.
virtual bool | getAutoextend (void) const
| Returns true if the billboard pool automatically extends.
virtual void | setSortingEnabled (bool sortenable)
| Enables sorting for this BillboardSet.
virtual bool | getSortingEnabled (void) const
| Returns true if sorting of billboards is enabled based on their distance from the camera.
virtual void | setPoolSize (size_t size)
| Adjusts the size of the pool of billboards available in this set.
virtual unsigned int | getPoolSize (void) const
| Returns the current size of the billboard pool.
virtual void | clear ()
| Empties this set of all billboards.
virtual Billboard * | getBillboard (unsigned int index) const
| Returns a pointer to the billboard at the supplied index.
virtual void | removeBillboard (unsigned int index)
| Removes the billboard at the supplied index.
virtual void | removeBillboard (Billboard *pBill)
| Removes a billboard from the set.
virtual void | setBillboardOrigin (BillboardOrigin origin)
| Sets the point which acts as the origin point for all billboards in this set.
virtual BillboardOrigin | getBillboardOrigin (void) const
| Gets the point which acts as the origin point for all billboards in this set.
virtual void | setBillboardRotationType (BillboardRotationType rotationType)
| Sets billboard rotation type.
virtual BillboardRotationType | getBillboardRotationType (void) const
| Sets billboard rotation type.
virtual void | setDefaultDimensions (Real width, Real height)
| Sets the default dimensions of the billboards in this set.
virtual void | setDefaultWidth (Real width)
| See setDefaultDimensions - this sets 1 component individually.
virtual Real | getDefaultWidth (void) const
| See setDefaultDimensions - this gets 1 component individually.
virtual void | setDefaultHeight (Real height)
| See setDefaultDimensions - this sets 1 component individually.
virtual Real | getDefaultHeight (void) const
| See setDefaultDimensions - this gets 1 component individually.
virtual void | setMaterialName (const String &name)
| Sets the name of the material to be used for this billboard set.
virtual const String & | getMaterialName (void) const
| Sets the name of the material to be used for this billboard set.
virtual void | _notifyCurrentCamera (Camera *cam)
| Overridden from MovableObject.
void | beginBillboards (size_t numBillboards=0)
| Begin injection of billboard data; applicable when constructing the BillboardSet for external data use.
void | injectBillboard (const Billboard &bb)
| Define a billboard.
void | endBillboards (void)
| Finish defining billboards.
void | setBounds (const AxisAlignedBox &box, Real radius)
| Set the bounds of the BillboardSet.
virtual const AxisAlignedBox & | getBoundingBox (void) const
| Overridden from MovableObject.
virtual Real | getBoundingRadius (void) const
| Overridden from MovableObject.
virtual void | _updateRenderQueue (RenderQueue *queue)
| Overridden from MovableObject.
virtual const MaterialPtr & | getMaterial (void) const
| Overridden from MovableObject.
virtual void | getRenderOperation (RenderOperation &op)
| Overridden from MovableObject.
virtual void | getWorldTransforms (Matrix4 *xform) const
| Overridden from MovableObject.
virtual void | _notifyBillboardResized (void)
| Internal callback used by Billboards to notify their parent that they have been resized.
virtual void | _notifyBillboardRotated (void)
| Internal callback used by Billboards to notify their parent that they have been rotated.
virtual bool | getCullIndividually (void) const
| Returns whether or not billboards in this are tested individually for culling.
virtual void | setCullIndividually (bool cullIndividual)
| Sets whether culling tests billboards in this individually as well as in a group.
virtual void | setBillboardType (BillboardType bbt)
| Sets the type of billboard to render.
virtual BillboardType | getBillboardType (void) const
| Returns the billboard type in use.
virtual void | setCommonDirection (const Vector3 &vec)
| Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON or BBT_PERPENDICULAR_COMMON.
virtual const Vector3 & | getCommonDirection (void) const
| Gets the common direction for all billboards (BBT_ORIENTED_COMMON).
virtual void | setCommonUpVector (const Vector3 &vec)
| Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON.
virtual const Vector3 & | getCommonUpVector (void) const
| Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON).
virtual void | setUseAccurateFacing (bool acc)
| Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.
virtual bool | getUseAccurateFacing (void) const
| Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.
virtual const String & | getMovableType (void) const
| Overridden from MovableObject.
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden, see Renderable.
virtual void | _updateBounds (void)
| Update the bounds of the billboardset.
const LightList & | getLights (void) const
| Gets a list of lights, ordered relative to how close they are to this renderable. Remarks: Directional lights, which have no position, will always be first on this list.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
  | Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any. Parameters:
  | visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  | debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.
virtual void | _sortBillboards (Camera *cam)
| Sort the billboard set.
virtual SortMode | _getSortMode (void) const
| Gets the sort mode of this billboard set.
virtual void | setBillboardsInWorldSpace (bool ws)
| Sets whether billboards should be treated as being in world space.
virtual void | setTextureCoords (Ogre::FloatRect const *coords, uint16 numCoords)
| BillboardSet can use custom texture coordinates for various billboards.
virtual void | setTextureStacksAndSlices (uchar stacks, uchar slices)
| setTextureStacksAndSlices() will generate texture coordinate rects as if the texture for the billboard set contained 'stacks' rows of 'slices' images each, all equal size.
virtual Ogre::FloatRect const * | getTextureCoords (uint16 *oNumCoords)
| getTextureCoords() returns the current texture coordinate rects in effect.
virtual void | setPointRenderingEnabled (bool enabled)
| Set whether or not the BillboardSet will use point rendering rather than manually generated quads.
virtual bool | isPointRenderingEnabled (void) const
| Returns whether point rendering is enabled.
uint32 | getTypeFlags (void) const
| Override to return specific type flag.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const String & | getName (void) const
| Returns the name of this object.
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual void | detatchFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
virtual void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserObject (UserDefinedObject *obj)
| Call this to associate your own custom user object instance with this MovableObject.
virtual UserDefinedObject * | getUserObject (void)
| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
virtual LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
EdgeData * | getEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
bool | hasEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDist, unsigned long flags=0)
| Define a default implementation of method from ShadowCaster which implements no shadows.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
virtual void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
virtual bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual RenderSystemData * | getRenderSystemData () const
| Sets render system private data.
virtual void | setRenderSystemData (RenderSystemData *val) const
| gets render system private data
## Static Public Member Functions
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.
## Protected Types
typedef std::list< Billboard * > | ActiveBillboardList
typedef std::list< Billboard * > | FreeBillboardList
typedef std::vector< Billboard * > | BillboardPool
typedef std::vector < Ogre::FloatRect > | TextureCoordSets
typedef std::map< String, StringVector > | AnimableDictionaryMap
typedef std::map< size_t, Vector4 > | CustomParameterMap
## Protected Member Functions
| BillboardSet ()
| Private constructor (instances cannot be created directly).
bool | billboardVisible (Camera *cam, const Billboard &bill)
| Internal method for culling individual billboards.
virtual void | increasePool (size_t size)
| Internal method for increasing pool size.
void | genBillboardAxes (Vector3 *pX, Vector3 *pY, const Billboard *pBill=0)
| Internal method for generating billboard corners.
void | getParametricOffsets (Real &left, Real &right, Real &top, Real &bottom)
| Internal method, generates parametric offsets based on origin.
void | genVertices (const Vector3 *const offsets, const Billboard &pBillboard)
| Internal method for generating vertex data.
void | genVertOffsets (Real inleft, Real inright, Real intop, Real inbottom, Real width, Real height, const Vector3 &x, const Vector3 &y, Vector3 *pDestVec)
| Internal method generates vertex offsets.
Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper method for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
virtual const String & | getAnimableDictionaryName (void) const
| Get the name of the animable dictionary for this class.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.
virtual void | initialiseAnimableDictionary (StringVector &) const
| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.
## Protected Attributes
AxisAlignedBox | mAABB
| Bounds of all billboards in this set.
Real | mBoundingRadius
| Bounding radius.
BillboardOrigin | mOriginType
| Origin of each billboard.
BillboardRotationType | mRotationType
| Rotation type of each billboard.
Real | mDefaultWidth
| Default width of each billboard.
Real | mDefaultHeight
| Default height of each billboard.
String | mMaterialName
| Name of the material to use.
MaterialPtr | mpMaterial
| Pointer to the material to use.
bool | mAllDefaultSize
| True if no billboards in this set have been resized - greater efficiency.
bool | mAutoExtendPool
| Flag indicating whether to autoextend pool.
bool | mSortingEnabled
| Flag indicating whether the billboards has to be sorted.
bool | mAccurateFacing
bool | mAllDefaultRotation
bool | mWorldSpace
ActiveBillboardList | mActiveBillboards
| Active billboard list.
FreeBillboardList | mFreeBillboards
| Free billboard queue.
BillboardPool | mBillboardPool
| Pool of billboard instances for use and reuse in the active billboard list.
VertexData * | mVertexData
| The vertex position data for all billboards in this set.
HardwareVertexBufferSharedPtr | mMainBuf
| Shortcut to main buffer (positions, colours, texture coords).
float * | mLockPtr
| Locked pointer to buffer.
Vector3 | mVOffset [4]
| Boundary offsets based on origin and camera orientation Vector3 vLeftOff, vRightOff, vTopOff, vBottomOff; Final vertex offsets, used where sizes all default to save calcs.
Camera * | mCurrentCamera
| Current camera.
Real | mLeftOff
Real | mRightOff
Real | mTopOff
Real | mBottomOff
Vector3 | mCamX
Vector3 | mCamY
Vector3 | mCamDir
Quaternion | mCamQ
Vector3 | mCamPos
IndexData * | mIndexData
| The vertex index data for all billboards in this set (1 set only).
bool | mCullIndividual
| Flag indicating whether each billboard should be culled separately (default: false).
TextureCoordSets | mTextureCoords
BillboardType | mBillboardType
| The type of billboard to render.
Vector3 | mCommonDirection
| Common direction for billboards of type BBT_ORIENTED_COMMON and BBT_PERPENDICULAR_COMMON.
Vector3 | mCommonUpVector
| Common up-vector for billboards of type BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON.
unsigned short | mNumVisibleBillboards
bool | mPointRendering
| Use point rendering?
String | mName
| Name of this object.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
bool | mDebugDisplay
| Is debug display enabled?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
Any | mUserAny
| User defined link to another object / value / whatever.
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
AxisAlignedBox | mWorldAABB
| Cached world AABB of this object.
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.
LightList | mLightList
| List of lights for this object.
ulong | mLightListUpdated
| The last frame that this light list was updated in.
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView
Any | mUserAny
RenderSystemData * | mRenderSystemData
## Static Protected Attributes
static RadixSort < ActiveBillboardList, Billboard *, float > | mRadixSorter
static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.
## Private Member Functions
void | _createBuffers (void)
| Internal method creates vertex and index buffers.
void | _destroyBuffers (void)
| Internal method destroys vertex and index buffers.
## Private Attributes
bool | mBuffersCreated
| Flag indicating whether the HW buffers have been created.
size_t | mPoolSize
| The number of billboard in the pool.
bool | mExternalData
| Is external billboard data in use?
## Classes
struct | SortByDirectionFunctor
| Sort by direction functor. More...
struct | SortByDistanceFunctor
| Sort by distance functor. More...

## Detailed Description

A collection of billboards (faces which are always facing the given direction) with the same (default) dimensions, material and which are fairly close proximity to each other.

Remarks:
  Billboards are rectangles made up of 2 tris which are always facing the given direction. They are typically used for special effects like particles. This class collects together a set of billboards with the same (default) dimensions, material and relative locality in order to process them more efficiently. The entire set of billboards will be culled as a whole (by default, although this can be changed if you want a large set of billboards which are spread out and you want them culled individually), individual Billboards have locations which are relative to the set (which itself derives it's position from the SceneNode it is attached to since it is a MoveableObject), they will be rendered as a single rendering operation, and some calculations will be sped up by the fact that they use the same dimensions so some workings can be reused.

  A BillboardSet can be created using the SceneManager::createBillboardSet method. They can also be used internally by other classes to create effects.

Note:
  Billboard bounds are only automatically calculated when you create them. If you modify the position of a billboard you may need to call _updateBounds if the billboard moves outside the original bounds. Similarly, the bounds do no shrink when you remove a billboard, if you want them to call _updateBounds, but note this requires a potentially expensive examination of every billboard in the set.

Definition at line 103 of file OgreBillboardSet.h.

## Member Typedef Documentation

typedef std::list<Billboard*> Ogre::BillboardSet::ActiveBillboardList`[protected]`

Definition at line 145 of file OgreBillboardSet.h.

typedef std::list<Billboard*> Ogre::BillboardSet::FreeBillboardList`[protected]`

Definition at line 146 of file OgreBillboardSet.h.

typedef std::vector<Billboard*> Ogre::BillboardSet::BillboardPool`[protected]`

Definition at line 147 of file OgreBillboardSet.h.

typedef std::vector< Ogre::FloatRect > Ogre::BillboardSet::TextureCoordSets`[protected]`

Definition at line 204 of file OgreBillboardSet.h.

typedef std::vector<ShadowRenderable*> Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

Definition at line 123 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

Definition at line 124 of file OgreShadowCaster.h.

typedef std::map<String, StringVector> Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

Definition at line 234 of file OgreAnimable.h.

typedef std::map<size_t, Vector4> Ogre::Renderable::CustomParameterMap`[protected, inherited]`

Definition at line 371 of file OgreRenderable.h.

## Constructor & Destructor Documentation

Ogre::BillboardSet::BillboardSet | ( |  | ) | `[protected]`

Private constructor (instances cannot be created directly).

Ogre::BillboardSet::BillboardSet | ( | const String & | name,
|  | unsigned int | poolSize = `20`,
|  | bool | externalDataSource = `false` |
| ) |  |  |

Usual constructor - this is called by the SceneManager.

Parameters:

  | name | The name to give the billboard set (must be unique)
  | poolSize | The initial size of the billboard pool. Estimate of the number of billboards which will be required, and pass it using this parameter. The set will preallocate this number to avoid memory fragmentation. The default behaviour once this pool has run out is to double it.
  | externalDataSource | If true, the source of data for drawing the billboards will not be the internal billboard list, but external data. When driving the billboard from external data, you must call _notifyCurrentCamera to reorient the billboards, setPoolSize to set the maximum billboards you want to use, beginBillboards to start the update, and injectBillboard per billboard, followed by endBillboards.

See also:
  BillboardSet::setAutoextend

virtual Ogre::BillboardSet::~BillboardSet | ( |  | ) | `[virtual]`

## Member Function Documentation

bool Ogre::BillboardSet::billboardVisible | ( | Camera * | cam,
|  | const Billboard & | bill |
| ) |  |  | `[protected]`

Internal method for culling individual billboards.

virtual void Ogre::BillboardSet::increasePool | ( | size_t | size | ) | `[protected, virtual]`

Internal method for increasing pool size.

void Ogre::BillboardSet::genBillboardAxes | ( | Vector3 * | pX,
|  | Vector3 * | pY,
|  | const Billboard * | pBill = `0` |
| ) |  |  | `[protected]`

Internal method for generating billboard corners.

Remarks:
  Optional parameter pBill is only present for type BBT_ORIENTED_SELF and BBT_PERPENDICULAR_SELF

void Ogre::BillboardSet::getParametricOffsets | ( | Real & | left,
|  | Real & | right,
|  | Real & | top,
|  | Real & | bottom |
| ) |  |  | `[protected]`

Internal method, generates parametric offsets based on origin.

void Ogre::BillboardSet::genVertices | ( | const Vector3 *const | offsets,
|  | const Billboard & | pBillboard |
| ) |  |  | `[protected]`

Internal method for generating vertex data.

Parameters:

  | offsets | Array of 4 Vector3 offsets
  | bb | Reference to billboard

void Ogre::BillboardSet::genVertOffsets | ( | Real | inleft,
|  | Real | inright,
|  | Real | intop,
|  | Real | inbottom,
|  | Real | width,
|  | Real | height,
|  | const Vector3 & | x,
|  | const Vector3 & | y,
|  | Vector3 * | pDestVec |
| ) |  |  | `[protected]`

Internal method generates vertex offsets.

Remarks:
  Takes in parametric offsets as generated from getParametericOffsets, width and height values and billboard x and y axes as generated from genBillboardAxes. Fills output array of 4 vectors with vector offsets from origin for left-top, right-top, left-bottom, right-bottom corners.

void Ogre::BillboardSet::_createBuffers | ( | void |  | ) | `[private]`

Internal method creates vertex and index buffers.

void Ogre::BillboardSet::_destroyBuffers | ( | void |  | ) | `[private]`

Internal method destroys vertex and index buffers.

Billboard* Ogre::BillboardSet::createBillboard | ( | const Vector3 & | position,
|  | const ColourValue & | colour = `ColourValue::White` |
| ) |  |  |

Creates a new billboard and adds it to this set.

Remarks:
  Behaviour once the billboard pool has been exhausted depends on the BillboardSet::setAutoextendPool option.

Parameters:

  | position | The position of the new billboard realtive to the certer of the set
  | colour | Optional base colour of the billboard.

Returns:
  On success, a pointer to a newly created Billboard is returned.

  On failiure (i.e. no more space and can't autoextend), NULL is returned.

See also:
  BillboardSet::setAutoextend

Billboard* Ogre::BillboardSet::createBillboard | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | const ColourValue & | colour = `ColourValue::White` |
| ) |  |  |

Creates a new billboard and adds it to this set.

Remarks:
  Behaviour once the billboard pool has been exhausted depends on the BillboardSet::setAutoextendPool option.

Parameters:

  | x |
  | y |
  | z | The position of the new billboard relative to the center of the set
  | colour | Optional base colour of the billboard.

Returns:
  On success, a pointer to a newly created Billboard is returned.

  On failure (i.e. no more space and can't autoextend), NULL is returned.

See also:
  BillboardSet::setAutoextend

virtual int Ogre::BillboardSet::getNumBillboards | ( | void |  | ) | const`[virtual]`

Returns the number of active billboards which currently make up this set.

virtual void Ogre::BillboardSet::setAutoextend | ( | bool | autoextend | ) | `[virtual]`

Tells the set whether to allow automatic extension of the pool of billboards.

Remarks:
  A BillboardSet stores a pool of pre-constructed billboards which are used as needed when a new billboard is requested. This allows applications to create / remove billboards efficiently without incurring construction / destruction costs (a must for sets with lots of billboards like particle effects). This method allows you to configure the behaviour when a new billboard is requested but the billboard pool has been exhausted.

  The default behaviour is to allow the pool to extend (typically this allocates double the current pool of billboards when the pool is expended), equivalent to calling this method with autoExtend = true. If you set the parameter to false however, any attempt to create a new billboard when the pool has expired will simply fail silently, returning a null pointer.

Parameters:

  | autoextend | true to double the pool every time it runs out, false to fail silently.

virtual bool Ogre::BillboardSet::getAutoextend | ( | void |  | ) | const`[virtual]`

Returns true if the billboard pool automatically extends.

See also:
  BillboardSet::setAutoextend

virtual void Ogre::BillboardSet::setSortingEnabled | ( | bool | sortenable | ) | `[virtual]`

Enables sorting for this BillboardSet.

(default: off)

Parameters:

  | sortenable | true to sort the billboards according to their distance to the camera

virtual bool Ogre::BillboardSet::getSortingEnabled | ( | void |  | ) | const`[virtual]`

Returns true if sorting of billboards is enabled based on their distance from the camera.

See also:
  BillboardSet::setSortingEnabled

virtual void Ogre::BillboardSet::setPoolSize | ( | size_t | size | ) | `[virtual]`

Adjusts the size of the pool of billboards available in this set.

Remarks:
  See the BillboardSet::setAutoextend method for full details of the billboard pool. This method adjusts the preallocated size of the pool. If you try to reduce the size of the pool, the set has the option of ignoring you if too many billboards are already in use. Bear in mind that calling this method will incur significant construction / destruction calls so should be avoided in time-critical code. The same goes for auto-extension, try to avoid it by estimating the pool size correctly up-front.

Parameters:

  | size | The new size for the pool.

virtual unsigned int Ogre::BillboardSet::getPoolSize | ( | void |  | ) | const`[virtual]`

Returns the current size of the billboard pool.

Returns:
  The current size of the billboard pool.

See also:
  BillboardSet::setAutoextend

virtual void Ogre::BillboardSet::clear | ( |  | ) | `[virtual]`

Empties this set of all billboards.

virtual Billboard* Ogre::BillboardSet::getBillboard | ( | unsigned int | index | ) | const`[virtual]`

Returns a pointer to the billboard at the supplied index.

Note:
  This method requires linear time since the billboard list is a linked list.

Parameters:

  | index | The index of the billboard that is requested.

Returns:
  On success, a valid pointer to the requested billboard is returned.

  On failure, NULL is returned.

virtual void Ogre::BillboardSet::removeBillboard | ( | unsigned int | index | ) | `[virtual]`

Removes the billboard at the supplied index.

Note:
  This method requires linear time since the billboard list is a linked list.

virtual void Ogre::BillboardSet::removeBillboard | ( | Billboard * | pBill | ) | `[virtual]`

Removes a billboard from the set.

Note:
  This version is more efficient than removing by index.

virtual void Ogre::BillboardSet::setBillboardOrigin | ( | BillboardOrigin | origin | ) | `[virtual]`

Sets the point which acts as the origin point for all billboards in this set.

Remarks:
  This setting controls the fine tuning of where a billboard appears in relation to it's position. It could be that a billboard's position represents it's center (e.g. for fireballs), it could mean the center of the bottom edge (e.g. a tree which is positioned on the ground), the top-left corner (e.g. a cursor).

  The default setting is BBO_CENTER.

Parameters:

  | origin | A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

virtual BillboardOrigin Ogre::BillboardSet::getBillboardOrigin | ( | void |  | ) | const`[virtual]`

Gets the point which acts as the origin point for all billboards in this set.

Returns:
  A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

virtual void Ogre::BillboardSet::setBillboardRotationType | ( | BillboardRotationType | rotationType | ) | `[virtual]`

Sets billboard rotation type.

Remarks:
  This setting controls the billboard rotation type, you can deciding rotate the billboard's vertices around their facing direction or rotate the billboard's texture coordinates.

  The default settings is BBR_TEXCOORD.

Parameters:

  | rotationType | A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

virtual BillboardRotationType Ogre::BillboardSet::getBillboardRotationType | ( | void |  | ) | const`[virtual]`

Sets billboard rotation type.

Returns:
  A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

virtual void Ogre::BillboardSet::setDefaultDimensions | ( | Real | width,
|  | Real | height |
| ) |  |  | `[virtual]`

Sets the default dimensions of the billboards in this set.

Remarks:
  All billboards in a set are created with these default dimensions. The set will render most efficiently if all the billboards in the set are the default size. It is possible to alter the size of individual billboards at the expense of extra calculation. See the Billboard class for more info.

Parameters:

  | width | The new default width for the billboards in this set.
  | height | The new default height for the billboards in this set.

virtual void Ogre::BillboardSet::setDefaultWidth | ( | Real | width | ) | `[virtual]`

See setDefaultDimensions - this sets 1 component individually.

virtual Real Ogre::BillboardSet::getDefaultWidth | ( | void |  | ) | const`[virtual]`

See setDefaultDimensions - this gets 1 component individually.

virtual void Ogre::BillboardSet::setDefaultHeight | ( | Real | height | ) | `[virtual]`

See setDefaultDimensions - this sets 1 component individually.

virtual Real Ogre::BillboardSet::getDefaultHeight | ( | void |  | ) | const`[virtual]`

See setDefaultDimensions - this gets 1 component individually.

virtual void Ogre::BillboardSet::setMaterialName | ( | const String & | name | ) | `[virtual]`

Sets the name of the material to be used for this billboard set.

Parameters:

  | name | The new name of the material to use for this set.

virtual const String& Ogre::BillboardSet::getMaterialName | ( | void |  | ) | const`[virtual]`

Sets the name of the material to be used for this billboard set.

Returns:
  The name of the material that is used for this set.

virtual void Ogre::BillboardSet::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Reimplemented from Ogre::MovableObject.

void Ogre::BillboardSet::beginBillboards | ( | size_t | numBillboards = `0` | ) |

Begin injection of billboard data; applicable when constructing the BillboardSet for external data use.

Parameters:

  | numBillboards | If you know the number of billboards you will be issuing, state it here to make the update more efficient.

void Ogre::BillboardSet::injectBillboard | ( | const Billboard & | bb | ) |

Define a billboard.

void Ogre::BillboardSet::endBillboards | ( | void |  | ) |

Finish defining billboards.

void Ogre::BillboardSet::setBounds | ( | const AxisAlignedBox & | box,
|  | Real | radius |
| ) |  |  |

Set the bounds of the BillboardSet.

Remarks:
  You may need to call this if you're injecting billboards manually, and you're relying on the BillboardSet to determine culling.

virtual const AxisAlignedBox& Ogre::BillboardSet::getBoundingBox | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Implements Ogre::MovableObject.

virtual Real Ogre::BillboardSet::getBoundingRadius | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Implements Ogre::MovableObject.

virtual void Ogre::BillboardSet::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Implements Ogre::MovableObject.

virtual const MaterialPtr& Ogre::BillboardSet::getMaterial | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Implements Ogre::Renderable.

virtual void Ogre::BillboardSet::getRenderOperation | ( | RenderOperation & | op | ) | `[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Implements Ogre::Renderable.

virtual void Ogre::BillboardSet::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Implements Ogre::Renderable.

virtual void Ogre::BillboardSet::_notifyBillboardResized | ( | void |  | ) | `[virtual]`

Internal callback used by Billboards to notify their parent that they have been resized.

virtual void Ogre::BillboardSet::_notifyBillboardRotated | ( | void |  | ) | `[virtual]`

Internal callback used by Billboards to notify their parent that they have been rotated.

virtual bool Ogre::BillboardSet::getCullIndividually | ( | void |  | ) | const`[virtual]`

Returns whether or not billboards in this are tested individually for culling.

virtual void Ogre::BillboardSet::setCullIndividually | ( | bool | cullIndividual | ) | `[virtual]`

Sets whether culling tests billboards in this individually as well as in a group.

Remarks:
  Billboard sets are always culled as a whole group, based on a bounding box which encloses all billboards in the set. For fairly localised sets, this is enough. However, you can optionally tell the set to also cull individual billboards in the set, i.e. to test each individual billboard before rendering. The default is not to do this.

  This is useful when you have a large, fairly distributed set of billboards, like maybe trees on a landscape. You probably still want to group them into more than one set (maybe one set per section of landscape), which will be culled coarsely, but you also want to cull the billboards individually because they are spread out. Whilst you could have lots of single-tree sets which are culled separately, this would be inefficient to render because each tree would be issued as it's own rendering operation.

  By calling this method with a parameter of true, you can have large billboard sets which are spaced out and so get the benefit of batch rendering and coarse culling, but also have fine-grained culling so unnecessary rendering is avoided.

Parameters:

  | cullIndividual | If true, each billboard is tested before being sent to the pipeline as well as the whole set having to pass the coarse group bounding test.

virtual void Ogre::BillboardSet::setBillboardType | ( | BillboardType | bbt | ) | `[virtual]`

Sets the type of billboard to render.

Remarks:
  The default sort of billboard (BBT_POINT), always has both x and y axes parallel to the camera's local axes. This is fine for 'point' style billboards (e.g. flares, smoke, anything which is symmetrical about a central point) but does not look good for billboards which have an orientation (e.g. an elongated raindrop). In this case, the oriented billboards are more suitable (BBT_ORIENTED_COMMON or BBT_ORIENTED_SELF) since they retain an independant Y axis and only the X axis is generated, perpendicular to both the local Y and the camera Z.

  In some case you might want the billboard has fixed Z axis and doesn't need to face to camera (e.g. an aureola around the player and parallel to the ground). You can use BBT_PERPENDICULAR_SELF which the billboard plane perpendicular to the billboard own direction. Or BBT_PERPENDICULAR_COMMON which the billboard plane perpendicular to the common direction.

Note:
  BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON can't guarantee counterclockwise, you might use double-side material (cull_hardware node) to ensure no billboard are culled.

Parameters:

  | bbt | The type of billboard to render

virtual BillboardType Ogre::BillboardSet::getBillboardType | ( | void |  | ) | const`[virtual]`

Returns the billboard type in use.

virtual void Ogre::BillboardSet::setCommonDirection | ( | const Vector3 & | vec | ) | `[virtual]`

Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON or BBT_PERPENDICULAR_COMMON.

Remarks:
  Use BBT_ORIENTED_COMMON when you want oriented billboards but you know they are always going to be oriented the same way (e.g. rain in calm weather). It is faster for the system to calculate the billboard vertices if they have a common direction.

  The common direction also use in BBT_PERPENDICULAR_COMMON, in this case the common direction treat as Z axis, and an additional common up-vector was use to determine billboard X and Y axis.

See also:
  setCommonUpVector

Parameters:

  | vec | The direction for all billboards.

Note:
  The direction are use as is, never normalised in internal, user are supposed to normalise it himself.

virtual const Vector3& Ogre::BillboardSet::getCommonDirection | ( | void |  | ) | const`[virtual]`

Gets the common direction for all billboards (BBT_ORIENTED_COMMON).

virtual void Ogre::BillboardSet::setCommonUpVector | ( | const Vector3 & | vec | ) | `[virtual]`

Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON.

Remarks:
  Use BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON when you want oriented billboards perpendicular to specify direction vector (or, Z axis), and doesn't face to camera. In this case, we need an additional up-vector to determine the billboard X and Y axis. The generated billboard plane and X-axis guarantee perpendicular to specify direction.

See also:
  setCommonDirection

  The specify direction is billboard own direction when billboard type is BBT_PERPENDICULAR_SELF, and it's shared common direction when billboard type is BBT_PERPENDICULAR_COMMON.

Parameters:

  | vec | The up-vector for all billboards.

Note:
  The up-vector are use as is, never normalised in internal, user are supposed to normalise it himself.

virtual const Vector3& Ogre::BillboardSet::getCommonUpVector | ( | void |  | ) | const`[virtual]`

Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON).

virtual void Ogre::BillboardSet::setUseAccurateFacing | ( | bool | acc | ) | `[virtual]`

Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

Remarks:
  By default, the axes for all billboards are calculated using the camera's view direction, not the vector from the camera position to the billboard. The former is faster, and most of the time the difference is not noticeable. However for some purposes (e.g. very large, static billboards) the changing billboard orientation when rotating the camera can be off putting, therefore you can enable this option to use a more expensive, but more accurate version.

Parameters:

  | acc | True to use the slower but more accurate model. Default is false.

Definition at line 695 of file OgreBillboardSet.h.

virtual bool Ogre::BillboardSet::getUseAccurateFacing | ( | void |  | ) | const`[virtual]`

Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

Definition at line 700 of file OgreBillboardSet.h.

virtual const String& Ogre::BillboardSet::getMovableType | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

Implements Ogre::MovableObject.

Real Ogre::BillboardSet::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[virtual]`

Overridden, see Renderable.

Implements Ogre::Renderable.

virtual void Ogre::BillboardSet::_updateBounds | ( | void |  | ) | `[virtual]`

Update the bounds of the billboardset.

const LightList& Ogre::BillboardSet::getLights | ( | void |  | ) | const`[virtual]`

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks:
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

void Ogre::BillboardSet::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = `false` |
| ) |  |  | `[virtual]`

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters:

  | visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  | debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

virtual void Ogre::BillboardSet::_sortBillboards | ( | Camera * | cam | ) | `[virtual]`

Sort the billboard set.

Only called when enabled via setSortingEnabled

virtual SortMode Ogre::BillboardSet::_getSortMode | ( | void |  | ) | const`[virtual]`

Gets the sort mode of this billboard set.

virtual void Ogre::BillboardSet::setBillboardsInWorldSpace | ( | bool | ws | ) | `[virtual]`

Sets whether billboards should be treated as being in world space.

Remarks:
  This is most useful when you are driving the billboard set from an external data source.

Definition at line 728 of file OgreBillboardSet.h.

virtual void Ogre::BillboardSet::setTextureCoords | ( | Ogre::FloatRect const * | coords,
|  | uint16 | numCoords |
| ) |  |  | `[virtual]`

BillboardSet can use custom texture coordinates for various billboards.

This is useful for selecting one of many particle images out of a tiled texture sheet, or doing flipbook animation within a single texture.

  The generic functionality is setTextureCoords(), which will copy the texture coordinate rects you supply into internal storage for the billboard set. If your texture sheet is a square grid, you can also use setTextureStacksAndSlices() for more convenience, which will construct the set of texture coordinates for you.

  When a Billboard is created, it can be assigned a texture coordinate set from within the sets you specify (that set can also be re-specified later). When drawn, the billboard will use those texture coordinates, rather than the full 0-1 range.

Parameters:

  | coords | is a vector of texture coordinates (in UV space) to choose from for each billboard created in the set.
  | numCoords | is how many such coordinate rectangles there are to choose from.

Remarks:
  Set 'coords' to 0 and/or 'numCoords' to 0 to reset the texture coord rects to the initial set of a single rectangle spanning 0 through 1 in both U and V (i e, the entire texture).

See also:
  BillboardSet::setTextureStacksAndSlices() Billboard::setTexcoordIndex()

virtual void Ogre::BillboardSet::setTextureStacksAndSlices | ( | uchar | stacks,
|  | uchar | slices |
| ) |  |  | `[virtual]`

setTextureStacksAndSlices() will generate texture coordinate rects as if the texture for the billboard set contained 'stacks' rows of 'slices' images each, all equal size.

Thus, if the texture size is 512x512 and 'stacks' is 4 and 'slices' is 8, each sub-rectangle of the texture would be 128 texels tall and 64 texels wide.

Remarks:
  This function is short-hand for creating a regular set and calling setTextureCoords() yourself. The numbering used for Billboard::setTexcoordIndex() counts first across, then down, so top-left is 0, the one to the right of that is 1, and the lower-right is stacks*slices-1.

See also:
  BillboardSet::setTextureCoords()

virtual Ogre::FloatRect const* Ogre::BillboardSet::getTextureCoords | ( | uint16 * | oNumCoords | ) | `[virtual]`

getTextureCoords() returns the current texture coordinate rects in effect.

By default, there is only one texture coordinate rect in the set, spanning the entire texture from 0 through 1 in each direction.

See also:
  BillboardSet::setTextureCoords()

virtual void Ogre::BillboardSet::setPointRenderingEnabled | ( | bool | enabled | ) | `[virtual]`

Set whether or not the BillboardSet will use point rendering rather than manually generated quads.

Remarks:
  By default a billboardset is rendered by generating geometry for a textured quad in memory, taking into account the size and orientation settings, and uploading it to the video card. The alternative is to use hardware point rendering, which means that only one position needs to be sent per billboard rather than 4 and the hardware sorts out how this is rendered based on the render state.

  Using point rendering is faster than generating quads manually, but is more restrictive. The following restrictions apply:
  - Only the BBT_POINT type is supported
  - Size and appearance of each billboard is controlled by the material (Pass::setPointSize, Pass::setPointSizeAttenuation, Pass::setPointSpritesEnabled)
  - Per-billboard size is not supported (stems from the above)
  - Per-billboard rotation is not supported, this can only be controlled through texture unit rotation
  - Only BBO_CENTER origin is supported
  - Per-billboard texture coordinates are not supported

  You will almost certainly want to enable in your material pass both point attenuation and point sprites if you use this option.

Parameters:

  | enabled | True to enable point rendering, false otherwise

virtual bool Ogre::BillboardSet::isPointRenderingEnabled | ( | void |  | ) | const`[virtual]`

Returns whether point rendering is enabled.

Definition at line 813 of file OgreBillboardSet.h.

uint32 Ogre::BillboardSet::getTypeFlags | ( | void |  | ) | const`[virtual]`

Override to return specific type flag.

Reimplemented from Ogre::MovableObject.

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

Notify the object of it's creator (internal use only).

Definition at line 169 of file OgreMovableObject.h.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

Get the creator of this object, if any (internal use only).

Definition at line 171 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

Notify the object of it's manager (internal use only).

Definition at line 173 of file OgreMovableObject.h.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

Get the manager of this object, if any (internal use only).

Definition at line 175 of file OgreMovableObject.h.

virtual const String& Ogre::MovableObject::getName | ( | void |  | ) | const`[virtual, inherited]`

Returns the name of this object.

Reimplemented in Ogre::Camera.

Definition at line 178 of file OgreMovableObject.h.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the scene node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false` |
| ) |  |  | `[virtual, inherited]`

Internal method called to notify the object that it has been attached to a node.

Reimplemented in Ogre::Entity, Ogre::Light, and Ogre::ParticleSystem.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint.

virtual void Ogre::MovableObject::detatchFromParent | ( | void |  | ) | `[virtual, inherited]`

Detaches an object from a parent SceneNode or TagPoint, if attached.

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

virtual void Ogre::MovableObject::_notifyMoved | ( | void |  | ) | `[virtual, inherited]`

Internal method called to notify the object that it has been moved.

Reimplemented in Ogre::Light.

virtual const AxisAlignedBox& Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

Retrieves the axis-aligned bounding box for this object in world coordinates.

Implements Ogre::ShadowCaster.

Reimplemented in Ogre::Entity.

virtual const Sphere& Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

Retrieves the worldspace bounding sphere for this object.

Reimplemented in Ogre::Entity.

virtual void Ogre::MovableObject::setVisible | ( | bool | visible | ) | `[virtual, inherited]`

Tells this object whether to be visible or not, if it has a renderable component.

Note:
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

Reimplemented in Ogre::Light.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

Gets this object whether to be visible or not, if it has a renderable component.

Remarks:
  Returns the value set by MovableObject::setVisible only.

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const`[virtual, inherited]`

Returns whether or not this object is supposed to be visible or not.

Remarks:
  Takes into account both upper rendering distance and visible flag.

Reimplemented in Ogre::InstancedGeometry::BatchInstance, and Ogre::StaticGeometry::Region.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

Sets the distance at which the object is no longer rendered.

Parameters:

  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).

Definition at line 280 of file OgreMovableObject.h.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

Gets the distance at which batches are no longer rendered.

Definition at line 286 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setUserObject | ( | UserDefinedObject * | obj | ) | `[virtual, inherited]`

Call this to associate your own custom user object instance with this MovableObject.

Remarks:
  By simply making your game / application object a subclass of UserDefinedObject, you can establish a link between an OGRE instance of MovableObject and your own application classes. Call this method to establish the link.

Definition at line 294 of file OgreMovableObject.h.

virtual UserDefinedObject* Ogre::MovableObject::getUserObject | ( | void |  | ) | `[virtual, inherited]`

Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.

Definition at line 298 of file OgreMovableObject.h.

References Ogre::any_cast().

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance.

Note:
  This value is shared with setUserObject so don't use both!

Definition at line 310 of file OgreMovableObject.h.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

Retrieves the custom user value associated with this object.

Definition at line 314 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual, inherited]`

Sets the render queue group this entity will be rendered through.

Remarks:
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters:

  | queueID | Enumerated value of the queue group to use.

Reimplemented in Ogre::Entity, and Ogre::ParticleSystem.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

Gets the queue group for this entity, see setRenderQueueGroup for full details.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

return the full transformation of the parent sceneNode or the attachingPoint node

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the query flags for this object.

Remarks:
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

Definition at line 342 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 346 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 350 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the query flags relevant for this object.

Definition at line 353 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default query flags for all future MovableObject instances.

Definition at line 357 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

Get the default query flags for all future MovableObject instances.

Definition at line 361 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the visiblity flags for this object.

Remarks:
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible.

Definition at line 370 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 374 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 378 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the visibility flags relevant for this object.

Definition at line 381 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default visibility flags for all future MovableObject instances.

Definition at line 385 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

Get the default visibility flags for all future MovableObject instances.

Definition at line 389 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this object.

Remarks:
  Note for size and performance reasons only one listener per object is allowed.

Definition at line 396 of file OgreMovableObject.h.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

Gets the current listener for this object.

Definition at line 400 of file OgreMovableObject.h.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks:
  By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list.

  The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed (

See also:
  SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance.

  This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable.

Returns:
  The list of lights use to lighting this object.

virtual LightList* Ogre::MovableObject::_getLightList | ( |  | ) | `[virtual, inherited]`

Returns a pointer to the current list of lights for this object.

Remarks:
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

Definition at line 428 of file OgreMovableObject.h.

EdgeData* Ogre::MovableObject::getEdgeList | ( | void |  | ) | `[virtual, inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Implements Ogre::ShadowCaster.

Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Definition at line 431 of file OgreMovableObject.h.

bool Ogre::MovableObject::hasEdgeList | ( | void |  | ) | `[virtual, inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Implements Ogre::ShadowCaster.

Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Definition at line 433 of file OgreMovableObject.h.

ShadowRenderableListIterator Ogre::MovableObject::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDist,
|  | unsigned long | flags = `0` |
| ) |  |  | `[virtual, inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Implements Ogre::ShadowCaster.

Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[virtual, inherited]`

Overridden member from ShadowCaster.

Implements Ogre::ShadowCaster.

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist |
| ) |  |  | const`[virtual, inherited]`

Overridden member from ShadowCaster.

Implements Ogre::ShadowCaster.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

Sets whether or not this object will cast shadows.

Remarks:
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note:
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

Definition at line 456 of file OgreMovableObject.h.

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[virtual, inherited]`

Returns whether shadow casting is enabled for this object.

Implements Ogre::ShadowCaster.

Definition at line 458 of file OgreMovableObject.h.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[virtual, inherited]`

Get the distance to extrude for a point/spot light.

Implements Ogre::ShadowCaster.

virtual void Ogre::MovableObject::setDebugDisplayEnabled | ( | bool | enabled | ) | `[virtual, inherited]`

Sets whether or not the debug display of this object is enabled.

Remarks:
  Some objects aren't visible themselves but it can be useful to display a debug representation of them. Or, objects may have an additional debug display on top of their regular display. This option enables / disables that debug display. Objects that are not visible never display debug geometry regardless of this setting.

Definition at line 495 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::isDebugDisplayEnabled | ( | void |  | ) | const`[virtual, inherited]`

Gets whether debug display of this object is enabled.

Definition at line 497 of file OgreMovableObject.h.

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | `[static, inherited]`

Utility method for extruding vertices based on a light.

Remarks:
  Unfortunately, because D3D cannot handle homogeneous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this.

Parameters:

  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, i.e. the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light |
| ) |  |  | const`[protected, inherited]`

Helper method for calculating extrusion distance.

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos |
| ) |  |  | `[protected, virtual, inherited]`

Tells the caster to perform the tasks necessary to update the edge data's light listing.

Can be overridden if the subclass needs to do additional things.

Parameters:

  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags |
| ) |  |  | `[protected, virtual, inherited]`

Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.

Parameters:

  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | const`[protected, virtual, inherited]`

Utility method for extruding a bounding box.

Parameters:

  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

virtual const String& Ogre::AnimableObject::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual, inherited]`

Get the name of the animable dictionary for this class.

Remarks:
  Subclasses must override this if they want to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 242 of file OgreAnimable.h.

References Ogre::StringUtil::BLANK.

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

Internal method for creating a dictionary of animable value names for the class, if it does not already exist.

Definition at line 247 of file OgreAnimable.h.

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

Get an updateable reference to animable value list.

Definition at line 260 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual void Ogre::AnimableObject::initialiseAnimableDictionary | ( | StringVector & |  | ) | const`[protected, virtual, inherited]`

Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.

Reimplemented in Ogre::Light.

Definition at line 280 of file OgreAnimable.h.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

Gets a list of animable value names for this object.

Definition at line 288 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) | `[virtual, inherited]`

Create a reference-counted AnimableValuePtr for the named value.

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 313 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

Retrieves a pointer to the Material Technique this renderable object uses.

Remarks:
  This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 87 of file OgreRenderable.h.

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys |
| ) |  |  | `[virtual, inherited]`

Called just prior to the Renderable being rendered.

Remarks:
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns:
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Definition at line 116 of file OgreRenderable.h.

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys |
| ) |  |  | `[virtual, inherited]`

Called immediately after the Renderable has been rendered.

Definition at line 119 of file OgreRenderable.h.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of world transform matrices this renderable requires.

Remarks:
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::BorderRenderable, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 143 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

Sets whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityProjection

Definition at line 154 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityProjection

Definition at line 168 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

Sets whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityView

Definition at line 179 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityView

Definition at line 193 of file OgreRenderable.h.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

Method which reports whether this renderable would normally cast a shadow.

Remarks:
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 214 of file OgreRenderable.h.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value |
| ) |  |  | `[inherited]`

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks:
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters:

  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.

Definition at line 231 of file OgreRenderable.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

Gets the custom value associated with this Renderable at the given index.

Parameters:

  | @see | setCustomParaemter for full details.

Definition at line 240 of file OgreRenderable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params |
| ) |  |  | const`[virtual, inherited]`

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks:
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters:

  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::SubEntity.

Definition at line 279 of file OgreRenderable.h.

References Ogre::GpuProgramParameters::_writeRawConstant(), Ogre::GpuProgramParameters::AutoConstantEntry::data, Ogre::GpuProgramParameters::AutoConstantEntry::elementCount, and Ogre::GpuProgramParameters::AutoConstantEntry::physicalIndex.

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters:

  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.

Definition at line 296 of file OgreRenderable.h.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Reimplemented in Ogre::BorderRenderable.

Definition at line 304 of file OgreRenderable.h.

virtual void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

Definition at line 315 of file OgreRenderable.h.

virtual const Any& Ogre::Renderable::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

Retrieves the custom user value associated with this object.

Definition at line 319 of file OgreRenderable.h.

virtual RenderSystemData* Ogre::Renderable::getRenderSystemData | ( |  | ) | const`[virtual, inherited]`

Sets render system private data.

Remarks:
  This should only be used by a render system

Definition at line 356 of file OgreRenderable.h.

virtual void Ogre::Renderable::setRenderSystemData | ( | RenderSystemData * | val | ) | const`[virtual, inherited]`

gets render system private data

Remarks:
  This should only be used by a render system

Definition at line 364 of file OgreRenderable.h.

## Member Data Documentation

AxisAlignedBox Ogre::BillboardSet::mAABB`[protected]`

Bounds of all billboards in this set.

Definition at line 111 of file OgreBillboardSet.h.

Real Ogre::BillboardSet::mBoundingRadius`[protected]`

Bounding radius.

Definition at line 113 of file OgreBillboardSet.h.

BillboardOrigin Ogre::BillboardSet::mOriginType`[protected]`

Origin of each billboard.

Definition at line 116 of file OgreBillboardSet.h.

BillboardRotationType Ogre::BillboardSet::mRotationType`[protected]`

Rotation type of each billboard.

Definition at line 118 of file OgreBillboardSet.h.

Real Ogre::BillboardSet::mDefaultWidth`[protected]`

Default width of each billboard.

Definition at line 121 of file OgreBillboardSet.h.

Real Ogre::BillboardSet::mDefaultHeight`[protected]`

Default height of each billboard.

Definition at line 123 of file OgreBillboardSet.h.

String Ogre::BillboardSet::mMaterialName`[protected]`

Name of the material to use.

Definition at line 126 of file OgreBillboardSet.h.

MaterialPtr Ogre::BillboardSet::mpMaterial`[protected]`

Pointer to the material to use.

Definition at line 128 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mAllDefaultSize`[protected]`

True if no billboards in this set have been resized - greater efficiency.

Definition at line 131 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mAutoExtendPool`[protected]`

Flag indicating whether to autoextend pool.

Definition at line 134 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mSortingEnabled`[protected]`

Flag indicating whether the billboards has to be sorted.

Definition at line 137 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mAccurateFacing`[protected]`

Definition at line 140 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mAllDefaultRotation`[protected]`

Definition at line 142 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mWorldSpace`[protected]`

Definition at line 143 of file OgreBillboardSet.h.

ActiveBillboardList Ogre::BillboardSet::mActiveBillboards`[protected]`

Active billboard list.

Remarks:
  This is a linked list of pointers to billboards in the billboard pool.

  This allows very fast insertions and deletions from anywhere in the list to activate / deactivate billboards (required for particle systems etc.) as well as reuse of Billboard instances in the pool without construction & destruction which avoids memory thrashing.

Definition at line 157 of file OgreBillboardSet.h.

FreeBillboardList Ogre::BillboardSet::mFreeBillboards`[protected]`

Free billboard queue.

Remarks:
  This contains a list of the billboards free for use as new instances as required by the set. Billboard instances are preconstructed up to the estimated size in the mBillboardPool vector and are referenced on this deque at startup. As they get used this deque reduces, as they get released back to to the set they get added back to the deque.

Definition at line 166 of file OgreBillboardSet.h.

BillboardPool Ogre::BillboardSet::mBillboardPool`[protected]`

Pool of billboard instances for use and reuse in the active billboard list.

Remarks:
  This vector will be preallocated with the estimated size of the set,and will extend as required.

Definition at line 172 of file OgreBillboardSet.h.

VertexData* Ogre::BillboardSet::mVertexData`[protected]`

The vertex position data for all billboards in this set.

Definition at line 175 of file OgreBillboardSet.h.

HardwareVertexBufferSharedPtr Ogre::BillboardSet::mMainBuf`[protected]`

Shortcut to main buffer (positions, colours, texture coords).

Definition at line 177 of file OgreBillboardSet.h.

float* Ogre::BillboardSet::mLockPtr`[protected]`

Locked pointer to buffer.

Definition at line 179 of file OgreBillboardSet.h.

Vector3 Ogre::BillboardSet::mVOffset[4]`[protected]`

Boundary offsets based on origin and camera orientation Vector3 vLeftOff, vRightOff, vTopOff, vBottomOff; Final vertex offsets, used where sizes all default to save calcs.

Definition at line 183 of file OgreBillboardSet.h.

Camera* Ogre::BillboardSet::mCurrentCamera`[protected]`

Current camera.

Definition at line 185 of file OgreBillboardSet.h.

Real Ogre::BillboardSet::mLeftOff`[protected]`

Definition at line 187 of file OgreBillboardSet.h.

Real Ogre::BillboardSet::mRightOff`[protected]`

Definition at line 187 of file OgreBillboardSet.h.

Real Ogre::BillboardSet::mTopOff`[protected]`

Definition at line 187 of file OgreBillboardSet.h.

Real Ogre::BillboardSet::mBottomOff`[protected]`

Definition at line 187 of file OgreBillboardSet.h.

Vector3 Ogre::BillboardSet::mCamX`[protected]`

Definition at line 189 of file OgreBillboardSet.h.

Vector3 Ogre::BillboardSet::mCamY`[protected]`

Definition at line 189 of file OgreBillboardSet.h.

Vector3 Ogre::BillboardSet::mCamDir`[protected]`

Definition at line 191 of file OgreBillboardSet.h.

Quaternion Ogre::BillboardSet::mCamQ`[protected]`

Definition at line 193 of file OgreBillboardSet.h.

Vector3 Ogre::BillboardSet::mCamPos`[protected]`

Definition at line 195 of file OgreBillboardSet.h.

IndexData* Ogre::BillboardSet::mIndexData`[protected]`

The vertex index data for all billboards in this set (1 set only).

Definition at line 199 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mCullIndividual`[protected]`

Flag indicating whether each billboard should be culled separately (default: false).

Definition at line 202 of file OgreBillboardSet.h.

TextureCoordSets Ogre::BillboardSet::mTextureCoords`[protected]`

Definition at line 205 of file OgreBillboardSet.h.

BillboardType Ogre::BillboardSet::mBillboardType`[protected]`

The type of billboard to render.

Definition at line 208 of file OgreBillboardSet.h.

Vector3 Ogre::BillboardSet::mCommonDirection`[protected]`

Common direction for billboards of type BBT_ORIENTED_COMMON and BBT_PERPENDICULAR_COMMON.

Definition at line 211 of file OgreBillboardSet.h.

Vector3 Ogre::BillboardSet::mCommonUpVector`[protected]`

Common up-vector for billboards of type BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON.

Definition at line 213 of file OgreBillboardSet.h.

unsigned short Ogre::BillboardSet::mNumVisibleBillboards`[protected]`

Definition at line 219 of file OgreBillboardSet.h.

RadixSort<ActiveBillboardList, Billboard*, float> Ogre::BillboardSet::mRadixSorter`[static, protected]`

Definition at line 279 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mPointRendering`[protected]`

Use point rendering?

Definition at line 282 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mBuffersCreated`[private]`

Flag indicating whether the HW buffers have been created.

Definition at line 288 of file OgreBillboardSet.h.

size_t Ogre::BillboardSet::mPoolSize`[private]`

The number of billboard in the pool.

Definition at line 290 of file OgreBillboardSet.h.

bool Ogre::BillboardSet::mExternalData`[private]`

Is external billboard data in use?

Definition at line 292 of file OgreBillboardSet.h.

String Ogre::MovableObject::mName`[protected, inherited]`

Name of this object.

Reimplemented in Ogre::Camera.

Definition at line 104 of file OgreMovableObject.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

Creator of this object (if created by a factory).

Definition at line 106 of file OgreMovableObject.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

SceneManager holding this object (if applicable).

Definition at line 108 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

node to which this object is attached

Definition at line 110 of file OgreMovableObject.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

Definition at line 111 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

Is this object visible?

Definition at line 113 of file OgreMovableObject.h.

bool Ogre::MovableObject::mDebugDisplay`[protected, inherited]`

Is debug display enabled?

Definition at line 115 of file OgreMovableObject.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

Upper distance to still render.

Definition at line 117 of file OgreMovableObject.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

Definition at line 118 of file OgreMovableObject.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

Hidden because of distance?

Definition at line 120 of file OgreMovableObject.h.

Any Ogre::MovableObject::mUserAny`[protected, inherited]`

User defined link to another object / value / whatever.

Definition at line 122 of file OgreMovableObject.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

The render queue to use when rendering this object.

Definition at line 124 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

Flags whether the RenderQueue's default should be used.

Definition at line 126 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

Flags determining whether this object is included / excluded from scene queries.

Definition at line 128 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

Flags determining whether this object is visible (compared to SceneManager mask).

Definition at line 130 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldAABB`[mutable, protected, inherited]`

Cached world AABB of this object.

Reimplemented in Ogre::ParticleSystem.

Definition at line 132 of file OgreMovableObject.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

Definition at line 134 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

World space AABB of this object's dark cap.

Definition at line 136 of file OgreMovableObject.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

Does this object cast shadows?

Definition at line 138 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

Does rendering this object disabled by listener?

Definition at line 141 of file OgreMovableObject.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

MovableObject listener - only one allowed (no list) for size & performance reasons. */.

Definition at line 143 of file OgreMovableObject.h.

LightList Ogre::MovableObject::mLightList`[mutable, protected, inherited]`

List of lights for this object.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 146 of file OgreMovableObject.h.

ulong Ogre::MovableObject::mLightListUpdated`[mutable, protected, inherited]`

The last frame that this light list was updated in.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 148 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

Default query flags.

Definition at line 152 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

Default visibility flags.

Definition at line 154 of file OgreMovableObject.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

Static map of class name to list of animable value names.

Definition at line 236 of file OgreAnimable.h.

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

Definition at line 372 of file OgreRenderable.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

Definition at line 373 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

Definition at line 374 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

Definition at line 375 of file OgreRenderable.h.

Any Ogre::Renderable::mUserAny`[protected, inherited]`

Definition at line 376 of file OgreRenderable.h.

RenderSystemData* Ogre::Renderable::mRenderSystemData`[mutable, protected, inherited]`

Definition at line 377 of file OgreRenderable.h.

The documentation for this class was generated from the following file:

- OgreBillboardSet.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:32:49 2009